; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    pmatch PROTO :DWORD,:DWORD

    .data
      sample db "1234567890abcdefghijklmnopqrstuvwxyz",0

      item1 db "12**56**",0         ; test start
      item2 db "**3456**",0
      item3 db "**uv**yz",0         ; test end
      item4 db "*tu*wx**",0
      item5 db "*9*****e*",0        ; test middle section
      item6 db "*456789*****efgh*****nop***",0
      item7 db "mismatch",0         ; test mismatch
      item8 db "k*m*o*q*s*",0

      align 4

      array dd item1,item2,item3,item4,item5,item6,item7,item8

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    cls

    push esi
    push edi

    mov esi, OFFSET array
    mov edi, 8

  @@:
    fn pmatch,ADDR sample,[esi]
    .if eax == -1
      print str$(eax)," No match",13,10
    .else
      push eax
      print "Matched at OFFSET "
      pop eax
      print str$(eax),13,10
    .endif
    add esi, 4
    sub edi, 1
    jnz @B

    pop edi
    pop esi

    ret

main endp

; 

align 4

pmatch proc psrc:DWORD,ppatn:DWORD

comment @ ----------------------------------------
        Partial string matching algorithm.
        Wildcard character is fixed at "*".
        Leading, mixed and trailing * allowed.

        Return values
        =============
        -1 NO match
        0 and greater = zero based offset of match
        ---------------------------------------- @

    LOCAL lead  :DWORD          ; number of filler chars at start
    LOCAL lsrc  :DWORD          ; source length in bytes
    LOCAL lptn  :DWORD          ; pattern length in bytes
    LOCAL mptn  :DWORD          ; matching pattern length
    LOCAL quit  :DWORD          ; exit offset for main loop

    push ebx
    push esi
    push edi

    invoke StrLen,ppatn
    mov lptn, eax               ; raw patn length
    invoke StrLen,psrc
    mov lsrc, eax               ; source length

    mov esi, psrc
    mov edi, ppatn
    sub edi, 1

  ; ----------------------------------------
  ; scan beginning of string for lead length
  ; ----------------------------------------
    mov lead, 0
    jmp @F
  lbl0:
    add lead, 1                 ; count the lead filler chars
  @@:
    add edi, 1                  ; increment EDI up to 1st non blank char
    cmp BYTE PTR [edi], "*"
    je lbl0
  ; ----------------------------------------

    mov eax, lptn
    sub eax, lead               ; sub lead from patn length
    mov mptn, eax               ; calc the len of the pattern to match
    sub mptn, 1

    mov bl, [edi]               ; 1st non filler char in BL
    add esi, lead               ; start counting the correct number
    sub esi, 1                  ; of characters in from start

  ; -----------------------
  ; calculate "quit" offset
  ; -----------------------
    mov eax, lsrc
    sub eax, lptn
    add eax, lead
    add eax, esi
    mov quit, eax
  ; -----------------------

  ; ****************************************************************

  mainloop:
    add esi, 1
    cmp [esi], bl               ; scan source for 1st non filler char
    je @F
    cmp esi, quit               ; test against exit offset
    jle mainloop
    jmp nomatch

  @@:
    mov edx, -1                 ; set index to -1
  matchloop:
    add edx, 1                  ; increment the index
    cmp edx, mptn               ; check against pattern length
    jg matched
    mov cl, [edi+edx]           ; load current byte in pattern
    cmp cl, 42                  ; test if its a filler "*"
    je matchloop
    cmp cl, [esi+edx]           ; else test if it matches
    je matchloop                ; at next character
    jmp mainloop

  ; ****************************************************************

  matched:
    sub esi, psrc
    sub esi, lead
    mov eax, esi
    jmp outa_here

  nomatch:
    mov eax, -1

  outa_here:
    pop edi
    pop esi
    pop ebx

    ret

pmatch endp

; 

end start
